Index: java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 84)
@@ -0,0 +1,54 @@
+package com.framsticks.gui.controls;
+
+import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+import javax.swing.JCheckBox;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.types.BooleanParam;
+
+@SuppressWarnings("serial")
+public class CheckBoxControl extends ValueControl {
+
+	private static final Logger log = Logger.getLogger(CheckBoxControl.class.getName());
+
+	protected final JCheckBox checkBox;
+
+	public CheckBoxControl(BooleanParam booleanParam) {
+		super(booleanParam);
+		checkBox = new JCheckBox();
+		checkBox.setEnabled(!isReadOnly());
+		checkBox.addActionListener(new ActionListener() {
+
+			@Override
+			public void actionPerformed(ActionEvent actionEvent) {
+				log.debug("change to: " + checkBox.isSelected());
+				notifyOfChange();
+			}
+		});
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
+		addAsOnlyChild(checkBox);
+	}
+
+	@Override
+	public void pushValueToUserInterfaceImpl(Object value) {
+		if (value == null) {
+			return;
+		}
+		checkBox.setSelected((Boolean) value);
+	}
+
+	@Override
+	public Object pullValueFromUserInterface() {
+		return checkBox.isSelected();
+	}
+
+	@Override
+	public BooleanParam getParam() {
+		return (BooleanParam) param;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 84)
@@ -0,0 +1,45 @@
+package com.framsticks.gui.controls;
+
+import com.framsticks.params.Flags;
+import com.framsticks.params.Param;
+import javax.swing.*;
+import java.awt.*;
+
+/**
+ * Interface that each class that want to be component must implement.
+ */
+@SuppressWarnings("serial")
+public abstract class Control extends JPanel {
+
+	public static final int LINE_HEIGHT = 36;
+
+	// private static final Logger log = Logger.getLogger(Control.class.getName());
+
+	protected Frame frame;
+	protected final Param param;
+
+	public Control(Param param) {
+		this.param = param;
+
+		this.setEnabled(!param.hasFlag(Flags.READONLY));
+		// TODO: take care of textField exception: setEditable
+	}
+
+	public Param getParam() {
+		return param;
+	}
+
+	public void setFrame(Frame frame) {
+		this.frame = frame;
+	}
+
+	protected void addAsOnlyChild(JComponent component) {
+		this.setLayout(new BorderLayout());
+		this.add(component, BorderLayout.CENTER);
+	}
+
+	@Override
+	public String toString() {
+		return param.toString();
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/ControlPopupListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ControlPopupListener.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/ControlPopupListener.java	(revision 84)
@@ -0,0 +1,40 @@
+package com.framsticks.gui.controls;
+
+import javax.swing.*;
+import java.awt.event.MouseAdapter;
+import java.awt.event.MouseEvent;
+
+/**
+ * Listener for component's JPopup menu.
+ */
+public class ControlPopupListener extends MouseAdapter {
+
+	private JPopupMenu popup;
+
+	public ControlPopupListener(JPopupMenu popup) {
+		this.popup = popup;
+	}
+
+	@Override
+	public void mousePressed(MouseEvent e) {
+		if (e.isPopupTrigger()) {
+			showPopup(e);
+		}
+	}
+
+	@Override
+	public void mouseReleased(MouseEvent e) {
+		if (e.isPopupTrigger()) {
+			showPopup(e);
+		}
+	}
+
+	/**
+	 * Shows popup menu if popup trigger fires.
+	 *
+	 * @param e MouseEvent on which popup menu will be showed.
+	 */
+	private void showPopup(MouseEvent e) {
+		popup.show(e.getComponent(), e.getX(), e.getY());
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 84)
@@ -0,0 +1,63 @@
+package com.framsticks.gui.controls;
+
+import com.framsticks.params.types.EnumParam;
+import com.framsticks.util.lang.Numbers;
+import org.apache.log4j.Logger;
+
+import javax.swing.*;
+
+import java.awt.Dimension;
+import java.awt.event.ItemEvent;
+import java.awt.event.ItemListener;
+
+@SuppressWarnings("serial")
+public class EnumControl extends ValueControl {
+
+	protected final JComboBox list;
+
+	private static final Logger log = Logger.getLogger(EnumControl.class.getName());
+
+	public EnumControl(EnumParam enumParam) {
+		super(enumParam);
+
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT));
+
+		list = new JComboBox();
+		for (String item : enumParam.getElements()) {
+			list.addItem(item);
+		}
+		list.setEditable(false);
+		list.setEnabled(!isReadOnly());
+		list.addItemListener(new ItemListener() {
+			@Override
+			public void itemStateChanged(ItemEvent itemEvent) {
+				notifyOfChange();
+			}
+		});
+		addAsOnlyChild(list);
+	}
+
+	@Override
+	public void pushValueToUserInterfaceImpl(Object value) {
+		Integer x = Numbers.cast(value, Integer.class);
+		if (x == null) {
+			return;
+		}
+		try {
+			list.setSelectedIndex(x - getParam().getMin(Integer.class));
+		} catch (IllegalArgumentException e) {
+			log.error("failed to set value");
+		}
+	}
+
+	@Override
+	public Object pullValueFromUserInterface() {
+		return list.getSelectedIndex();
+	}
+
+	@Override
+	public EnumParam getParam() {
+		return (EnumParam) param;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/EventControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 84)
@@ -0,0 +1,49 @@
+package com.framsticks.gui.controls;
+
+import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+import javax.swing.JButton;
+
+import com.framsticks.params.types.EventParam;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@SuppressWarnings("serial")
+public class EventControl extends Control {
+	// private static final Logger log = Logger.getLogger(EventControl.class.getName());
+
+	protected final JButton button;
+	boolean subscribed = true;
+
+	public EventControl(final EventParam eventParam) {
+		super(eventParam);
+
+		button = new JButton("subscribe");
+		this.add(button);
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
+
+		button.addActionListener(new ActionListener() {
+			@Override
+			public void actionPerformed(ActionEvent e) {
+				if (subscribed) {
+					//panel.getCurrentTreeNode().unsubscribe(eventParam);
+				} else {
+					//panel.getCurrentTreeNode().subscribe(eventParam);
+				}
+			}
+		});
+
+	}
+
+	/*
+	@Override
+	public void refresh() {
+		subscribed = panel.getCurrentTreeNode().hasSubscribed((EventParam)param);
+		button.setText(subscribed ? "unsubscribe" : "subscribe");
+		this.revalidate();
+	}
+	*/
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 84)
@@ -0,0 +1,65 @@
+package com.framsticks.gui.controls;
+
+import com.framsticks.gui.Gui;
+import com.framsticks.params.Param;
+import com.framsticks.params.types.ProcedureParam;
+
+import javax.swing.*;
+import javax.swing.border.BevelBorder;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.util.HashMap;
+import java.util.Map;
+
+@SuppressWarnings("serial")
+public class ProcedureControl extends Control {
+	// private static final Logger log = Logger.getLogger(Control.class.getName());
+
+	protected final JButton procedureButton;
+
+	final protected Map<Param, Control> components = new HashMap<Param, Control>();
+
+	public ProcedureControl(ProcedureParam procedureParam) {
+		super(procedureParam);
+
+		procedureButton = new JButton("Call");
+
+		this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
+
+		Gui.fillWithControls(this, procedureParam.getArgumentsType(), components);
+
+		if (components.size() != procedureParam.getArgumentsType().size()) {
+			procedureButton.setEnabled(false);
+		}
+		if (!components.isEmpty()) {
+			this.setBorder(new BevelBorder(BevelBorder.RAISED));
+		}
+
+		procedureButton.addActionListener(new ActionListener() {
+			@Override
+			public void actionPerformed(ActionEvent e) {
+
+/*
+				Node node = panel.getCurrentNode();
+				if (argumentWindow != null) {
+					argumentWindow.askForArguments();
+					return;
+				}
+				node.getConnection().send(new CallQuery().setMethod(param.getId()).setPath(node.getPath()).setCallback(new QueryCallback() {
+					@Override
+					public void call(boolean ok, String comment, SourceInterface content) {
+						if (!ok) {
+							log.error("failed to call method: " + param);
+							return;
+						}
+						log.debug("successful call of method: " + param);
+					}
+				}));
+*/
+			}
+		});
+		this.add(procedureButton);
+
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/SliderControl.java	(revision 84)
@@ -0,0 +1,208 @@
+package com.framsticks.gui.controls;
+
+import java.awt.BorderLayout;
+import java.awt.Dimension;
+import java.util.Hashtable;
+
+import javax.swing.Box;
+import javax.swing.BoxLayout;
+import javax.swing.JComponent;
+import javax.swing.JLabel;
+import javax.swing.JPanel;
+import javax.swing.JSlider;
+import javax.swing.JTextField;
+import javax.swing.event.ChangeEvent;
+import javax.swing.event.ChangeListener;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.Flags;
+import com.framsticks.params.types.DecimalParam;
+import com.framsticks.params.types.FloatParam;
+import com.framsticks.params.types.NumberParam;
+import com.framsticks.util.lang.Numbers;
+import com.framsticks.util.swing.Layout;
+
+@SuppressWarnings("serial")
+public class SliderControl extends TextControl {
+
+	private static final Logger log = Logger.getLogger(SliderControl.class.getName());
+
+	protected final JSlider slider;
+
+	protected final JTextField text;
+
+	/**
+	 * Division factor used to implement float value slider.
+	 */
+	private final int div = 10;
+	private JComponent changing = null;
+
+	private Class<? extends Number> valueType;
+
+	public SliderControl(NumberParam<?> param) {
+		super(param);
+		text = new JTextField();
+
+		//TODO: that factor should be done as a constant
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, (int)(LINE_HEIGHT * 1.2)));
+
+		// ComponentUI ui = UIManager.getUI(slider);
+		// assert ui instanceof SliderUI;
+		// SliderUI sui = (SliderUI) ui;
+		// slider.setUI(sui);
+
+		slider = new JSlider();
+
+		slider.setEnabled(!isReadOnly());
+		slider.setPaintLabels(false);
+		if (param instanceof DecimalParam) {
+			valueType = Integer.class;
+
+			int min = param.getMin(Integer.class);
+			int max = param.getMax(Integer.class);
+			slider.setMinimum(min);
+			slider.setMaximum(max);
+			if (param.getDef(Integer.class) != null) {
+				slider.setValue(param.getDef(Integer.class));
+			} else {
+				slider.setValue(min);
+			}
+			slider.setMajorTickSpacing((int) ((max - min) / 5));
+			slider.setMinorTickSpacing((int) ((max - min) / 10));
+		} else if (param instanceof FloatParam) {
+			valueType = Double.class;
+
+			double min = param.getMin(Double.class) * div;
+			slider.setMinimum((int) min);
+			double max = param.getMax(Double.class) * div;
+			double diff = max - min;
+			slider.setMaximum((int) max);
+
+			Hashtable<Integer, java.awt.Component> labels = new Hashtable<Integer, java.awt.Component>();
+			int ticks = 6;
+			for (int i = 0; i <= ticks; i++) {
+				double val = (diff / ticks) * i + min;
+				String label = String.format("%1$.1f", (val / 10)).replace(",",
+						".");
+				labels.put((int) val, new JLabel(label, JLabel.CENTER));
+			}
+			slider.setLabelTable(labels);
+			slider.setMajorTickSpacing((int) (diff / 5));
+			slider.setMinorTickSpacing((int) (diff / 10));
+			if (param.getDef(Double.class) != null) {
+				double defaultValue = param.getDef(Double.class) * div;
+				slider.setValue((int) defaultValue);
+			}
+		}
+		slider.setPaintLabels(true);
+		slider.setPaintTicks(true);
+
+		this.setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
+		this.setAlignmentX(Box.CENTER_ALIGNMENT);
+		this.setAlignmentY(Box.CENTER_ALIGNMENT);
+
+		JPanel sliderPanel = new JPanel();
+		sliderPanel.setLayout(new BoxLayout(sliderPanel, BoxLayout.LINE_AXIS));
+
+
+		Layout.fixComponentSize(text, new Dimension(90, Control.LINE_HEIGHT));
+		text.setHorizontalAlignment(JSlider.CENTER);
+
+		text.setEnabled(!param.hasFlag(Flags.READONLY));
+
+		slider.addChangeListener(new ChangeListener() {
+			@Override
+			public void stateChanged(ChangeEvent e) {
+				if (changing != null) {
+					return;
+				}
+				log.trace("changing " + getParam() + " with slider: " + slider.getValue());
+				changing = slider;
+				text.setText(convertFromSliderDomain(slider.getValue()).toString());
+				changing = null;
+			}
+		});
+
+		text.getDocument().addDocumentListener(createDocumentListener(new Runnable() {
+			@Override
+			public void run() {
+				if (changing != null) {
+					return;
+				}
+				log.trace("changing " + getParam() + " with text: " + text.getText());
+				changing = text;
+				Integer i = convertToSliderDomain(convertTextToNumber());
+				if (i != null) {
+					slider.setValue(i);
+				}
+				changing = null;
+				notifyOfChange();
+			}
+		}));
+
+		JPanel sVPanel = new JPanel();
+		sVPanel.setLayout(new BoxLayout(sVPanel, BoxLayout.LINE_AXIS));
+		sVPanel.add(text);
+		Layout.copyComponentDimensions(sVPanel, text);
+
+		JPanel sPanel = new JPanel();
+		sPanel.setLayout(new BoxLayout(sPanel, BoxLayout.LINE_AXIS));
+
+		sliderPanel.setLayout(new BorderLayout());
+		sliderPanel.add(slider, BorderLayout.CENTER);
+		sliderPanel.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
+		sliderPanel.setMinimumSize(new Dimension(0, 60));
+
+		sPanel.add(sVPanel);
+		sPanel.add(sliderPanel);
+
+		this.add(sPanel);
+	}
+
+	@Override
+	public NumberParam<?> getParam() {
+		return (NumberParam<?>) param;
+	}
+
+	private Number convertFromSliderDomain(int value) {
+		if (param instanceof DecimalParam) {
+			return value;
+		}
+		if (param instanceof FloatParam) {
+			return (double) value / (double) div;
+		}
+		return null;
+	}
+
+	private Integer convertToSliderDomain(Number value) {
+		if (value == null) {
+			return null;
+		}
+		if (param instanceof DecimalParam) {
+			return (Integer) value;
+		}
+		if (param instanceof FloatParam) {
+			return (int) ((Double) value * div);
+		}
+		return null;
+	}
+
+	private Number convertTextToNumber() {
+		return Numbers.cast(text.getText(), valueType);
+	}
+
+	@Override
+	public void pushValueToUserInterfaceImpl(Object value) {
+		if (value == null) {
+			return;
+		}
+		text.setText(value.toString());
+	}
+
+	@Override
+	public Number pullValueFromUserInterface() {
+		return convertTextToNumber();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextAreaControl.java	(revision 84)
@@ -0,0 +1,50 @@
+package com.framsticks.gui.controls;
+
+import com.framsticks.params.PrimitiveParam;
+
+import javax.swing.*;
+import java.awt.*;
+
+@SuppressWarnings("serial")
+public class TextAreaControl extends TextControl {
+
+	// private static final Logger log = Logger.getLogger(TextAreaControl.class.getName());
+
+	protected JTextArea textArea;
+	protected JScrollPane textScrollPane;
+
+	public TextAreaControl(PrimitiveParam valueParam) {
+		super(valueParam);
+		textArea = new JTextArea();
+		textArea.setLineWrap(true);
+		textArea.setWrapStyleWord(true);
+		textArea.setEditable(!isReadOnly());
+		addDefaultDocumentListener(textArea);
+
+		textScrollPane = new JScrollPane(textArea);
+		this.setLayout(new BorderLayout());
+		this.add(textScrollPane, BorderLayout.CENTER);
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
+		textArea.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT * 3));
+
+		this.revalidate();
+	}
+
+	@Override
+	public Dimension getPreferredSize() {
+		Dimension result = super.getPreferredSize();
+		return new Dimension(result.width, Math.min(result.height, this.getMaximumSize().height));
+	}
+
+	@Override
+	public void pushValueToUserInterfaceImpl(Object value) {
+		textArea.setText((String) value);
+		this.revalidate();
+	}
+
+	@Override
+	public Object pullValueFromUserInterface() {
+		return textArea.getText();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/TextControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextControl.java	(revision 84)
@@ -0,0 +1,43 @@
+package com.framsticks.gui.controls;
+
+import javax.swing.event.DocumentEvent;
+import javax.swing.event.DocumentListener;
+import javax.swing.text.JTextComponent;
+
+import com.framsticks.params.PrimitiveParam;
+
+@SuppressWarnings("serial")
+public abstract class TextControl extends ValueControl {
+
+	public TextControl(PrimitiveParam valueParam) {
+		super(valueParam);
+	}
+
+	protected void addDefaultDocumentListener(JTextComponent text) {
+		text.getDocument().addDocumentListener(createDocumentListener(new Runnable() {
+			@Override
+			public void run() {
+				notifyOfChange();
+			}
+		}));
+	}
+
+	protected static DocumentListener createDocumentListener(final Runnable runnable) {
+		return new DocumentListener() {
+			@Override
+			public void insertUpdate(DocumentEvent documentEvent) {
+				runnable.run();
+			}
+
+			@Override
+			public void removeUpdate(DocumentEvent documentEvent) {
+				runnable.run();
+			}
+
+			@Override
+			public void changedUpdate(DocumentEvent documentEvent) {
+				runnable.run();
+			}
+		};
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/TextFieldControl.java	(revision 84)
@@ -0,0 +1,49 @@
+package com.framsticks.gui.controls;
+
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.util.lang.Strings;
+
+import javax.swing.*;
+import java.awt.*;
+
+@SuppressWarnings("serial")
+public class TextFieldControl extends TextControl {
+
+
+	private static final Color CORRECT_COLOR = new Color(180, 255, 215);
+	private static final Color WRONG_COLOR = new Color(255, 180, 215);
+
+	protected final JTextField textField;
+
+	@Override
+	protected boolean notifyOfChange() {
+		boolean result = super.notifyOfChange();
+		textField.setBackground(result ? CORRECT_COLOR : WRONG_COLOR);
+		return result;
+	}
+
+	public TextFieldControl(PrimitiveParam valueParam) {
+		super(valueParam);
+		textField = new JTextField();
+
+		textField.setMinimumSize(new Dimension(0, Control.LINE_HEIGHT));
+		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
+
+		textField.setEditable(!isReadOnly());
+
+		addDefaultDocumentListener(textField);
+
+		addAsOnlyChild(textField);
+	}
+
+	@Override
+	public void pushValueToUserInterfaceImpl(Object text) {
+		textField.setText(Strings.toStringNullProof(text));
+	}
+
+	@Override
+	public Object pullValueFromUserInterface() {
+		return textField.getText();
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/ValueControl.java	(revision 84)
@@ -0,0 +1,96 @@
+package com.framsticks.gui.controls;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.params.CastFailure;
+import com.framsticks.params.Flags;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
+import com.framsticks.util.swing.TooltipConstructor;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@SuppressWarnings("serial")
+public abstract class ValueControl extends Control {
+	private static final Logger log =
+		Logger.getLogger(ValueControl.class);
+
+	/**
+	 *
+	 */
+	protected ValueControlListener listener;
+
+	public ValueControl(PrimitiveParam primitiveParam) {
+		super(primitiveParam);
+
+		this.setToolTipText(new TooltipConstructor()
+			.append("name", primitiveParam.getName())
+			.append("id", primitiveParam.getId())
+			.append("help", primitiveParam.getHelp())
+			.append("def", primitiveParam.getDef(Object.class))
+			.append("min", primitiveParam.getMin(Object.class))
+			.append("max", primitiveParam.getMax(Object.class))
+			.append("flags", Flags.write(primitiveParam.getFlags(), null))
+			.append("group", primitiveParam.getGroup())
+			.append("extra", primitiveParam.getExtra())
+			.build())
+			;
+	}
+
+	@Override
+	public PrimitiveParam getParam() {
+		return (PrimitiveParam) param;
+	}
+
+	protected abstract void pushValueToUserInterfaceImpl(Object value);
+
+	/** I consider this an ugly solution, but I was unable to find proper
+	 * action listeners for underlying swing controls, that would only fire
+	 * on user change and on programmatic change.
+	 */
+	protected boolean programmaticChange = false;
+
+	public void pushValueToUserInterface(Object value) {
+		programmaticChange = true;
+		pushValueToUserInterfaceImpl(value);
+		programmaticChange = false;
+	}
+
+	public abstract Object pullValueFromUserInterface();
+
+	public void setListener(ValueControlListener listener) {
+		this.listener = listener;
+	}
+
+	protected Object filterValueThroughConstraints(Object candidate) {
+		Object oldValue = pullValueFromUserInterface();
+		try {
+			ReassignResult<?> res = getParam().reassign(candidate, oldValue);
+			if (res.getFlags() != 0) {
+				log.warn("filter of param " + param + " failed: " + Flags.write(res.getFlags(), "0"));
+			}
+			return res.getValue();
+		} catch (CastFailure e) {
+			log.error("cast failure when setting param " + param + " to value " + candidate + ": " + e);
+		}
+		return oldValue;
+	}
+
+	protected boolean notifyOfChange() {
+		if (!programmaticChange) {
+			if (listener == null) {
+				return true;
+			}
+			return listener.onChange(filterValueThroughConstraints(pullValueFromUserInterface()));
+		}
+		return true;
+	}
+
+	public final boolean isReadOnly() {
+		return (param.getFlags() & Flags.READONLY) != 0;
+	}
+
+
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/ValueControlListener.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ValueControlListener.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/gui/controls/ValueControlListener.java	(revision 84)
@@ -0,0 +1,8 @@
+package com.framsticks.gui.controls;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public interface ValueControlListener {
+	public boolean onChange(Object newValue);
+}
Index: java/main/src/main/java/com/framsticks/gui/view/ColumnMenuItem.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/view/ColumnMenuItem.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/view/ColumnMenuItem.java	(revision 84)
@@ -46,5 +46,5 @@
 		this.addItemListener(new ItemListener() {
 			public void itemStateChanged(ItemEvent e) {
-				if (e.getStateChange() == e.SELECTED) {
+				if (e.getStateChange() == ItemEvent.SELECTED) {
 					columnManager.addColumn(ColumnMenuItem.this.columnName,
 							ColumnMenuItem.this.columnId,
Index: java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/view/TreeCellRenderer.java	(revision 84)
@@ -6,4 +6,7 @@
 import javax.swing.*;
 import javax.swing.tree.DefaultTreeCellRenderer;
+
+import org.apache.log4j.Logger;
+
 import java.awt.*;
 
@@ -13,15 +16,18 @@
 @SuppressWarnings("serial")
 public class TreeCellRenderer extends DefaultTreeCellRenderer {
+	private static final Logger log =
+		Logger.getLogger(TreeCellRenderer.class);
 
-    public TreeCellRenderer() {
-        setOpenIcon(null);
-        setClosedIcon(null);
-        setLeafIcon(null);
-    }
+
+	public TreeCellRenderer() {
+		setOpenIcon(null);
+		setClosedIcon(null);
+		setLeafIcon(null);
+	}
 
 	@Override
 	public Component getTreeCellRendererComponent(JTree tree, Object value,
-	                                              boolean sel, boolean expanded, boolean leaf, int row,
-	                                              boolean hasFocus) {
+			boolean sel, boolean expanded, boolean leaf, int row,
+			boolean hasFocus) {
 
 		//super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
@@ -31,21 +37,23 @@
 		}
 		if (!(value instanceof TreeNode)) {
-            setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
-            setText("framsticks");
+			setIcon(ImageProvider.loadImage(ImageProvider.SERVER));
+			setText("framsticks");
 			return this;
 		}
 		TreeNode treeNode = (TreeNode)value;
-        assert treeNode.getFrame().isActive();
-        setToolTipText(treeNode.getTooltip());
-        setIcon(ImageProvider.loadImage(treeNode.getIconName()));
-        setText(treeNode.getName());
+		assert treeNode.getFrame().isActive();
+		setToolTipText(treeNode.getTooltip());
+		setIcon(ImageProvider.loadImage(treeNode.getIconName()));
+		setText(treeNode.getName());
 		return this;
 	}
 
 	public static String findIconName(String nodeName, String path) {
-        if (path == null || nodeName == null) {
-            return null;
-        }
-        if (path.equals("/")) {
+		if (nodeName == null || path == null) {
+			log.warn("given invalid parameters: " + nodeName + " " + path);
+			// return null;
+			return ImageProvider.SERVER;
+		}
+		if (path.equals("/")) {
 			return ImageProvider.SERVER;
 		}
@@ -133,5 +141,5 @@
 		return ImageProvider.SERVER;
 	}
-	
-	
+
+
 }
Index: java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/gui/windows/ServerLogFrame.java	(revision 84)
@@ -2,5 +2,4 @@
 
 import com.framsticks.gui.ImageProvider;
-import com.framsticks.gui.components.Control;
 import org.apache.log4j.Logger;
 
